//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                             s-PSI@CalculateProfitLastCloseOrd.mq4 |
//|                                       Copyright  2013, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2013, TarasBY"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property show_inputs
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern int    MAGIC                    = 2013;        // MagicNumber
extern int    Type                     = -2;          // OrderType
extern int    Cnt_Orders               = 10;          //   
//IIIIIIIIIIIIII=IIIII======  =======IIIIIIIIIIIIIIIIIIIIII+
string bs_SymbolList, bs_MagicList, bs_Delimiter = ",";
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom script iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
//----
    bs_SymbolList = Symbol();
    bs_MagicList = MAGIC;
    double ld_Profit = fGet_ProfitLastCloseOrd (Cnt_Orders, Type);
    Comment ("PROFIT[", Cnt_Orders, "] = $ ", DoubleToStr (ld_Profit, 2));
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          Profit N                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_ProfitLastCloseOrd (int fi_NUM,          //   
                                int fi_Type = -2)    // OrderType()
{
    int      li_Ticket;
    double   ld_Profit = 0.;
    datetime ldt_Time = 0;
//----
    for (int li_IND = 0; li_IND < fi_NUM; li_IND++)
    {
        li_Ticket = fGet_TicketLastClosePos (fi_Type, 0, ldt_Time);
        if (li_Ticket > 0)
        {
            OrderSelect (li_Ticket, SELECT_BY_TICKET);
            ldt_Time = OrderCloseTime();
            ld_Profit += (OrderProfit() + OrderSwap() + OrderCommission());
        }
        else break;
    }
//----
    return (ld_Profit);
}//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         ""                                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_MyOrders (int li_pos,                //      OrdersTotal()
                      int fi_Type = -1,          //  
                      int fi_Pool = MODE_TRADES) //    
{
//----
    if (!OrderSelect (li_pos, SELECT_BY_POS, fi_Pool)) return (false);
    if (StringFind (bs_SymbolList, OrderSymbol()) < 0) {if (StringLen (bs_SymbolList) > 0) return (false);}
    if (!fCheck_MyMagic (bs_MagicList, bs_Delimiter)) return (false);
    if (!fCheck_TypeOrder (fi_Type, OrderType())) return (false);
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          Ticket   fdt_Time           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_TicketLastClosePos (int fi_Type = -2,          // OrderType()
                             int fi_TypeProfit = 0,     //   : 0 - , -1 - , 1 - 
                             datetime fdt_Time = 0)     //   
{
    datetime ldt_CloseTime = 0, ldt_LastTime = 0;
    double   ld_Profit = 0.;
    int      li_Ticket = 0, li_Total = OrdersHistoryTotal();
//----
    for (int li_ORD = li_Total - 1; li_ORD >= 0; li_ORD--)
    {
        if (!fCheck_MyOrders (li_ORD, fi_Type, MODE_HISTORY)) continue;
        ldt_CloseTime = OrderCloseTime();
        //----  ,    
        if (fdt_Time != 0) if (fdt_Time <= ldt_CloseTime) continue;
        if (ldt_LastTime >= ldt_CloseTime) continue;
        ld_Profit = OrderProfit();
        //----    
        if (fi_TypeProfit > 0) if (ld_Profit < 0.) continue;
        if (fi_TypeProfit < 0) if (ld_Profit > 0.) continue;
        ldt_LastTime = ldt_CloseTime;
        li_Ticket = OrderTicket();
    }
//----
    return (li_Ticket);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_TypeOrder (int fi_Type,      // -1 - ; -2 - ; 7 - 
                       int fi_CheckType) // OrderType
{
//----
    if (fi_Type >= 0)
    {
        if (fi_Type == 7) {if (fi_CheckType < 2) return (false);}
        else {if (fi_Type != fi_CheckType) return (false);}
    }
    else {if (fi_Type == -2) {if (fi_CheckType > 1) return (false);}}
    
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_MyMagic (string fs_List,             //  
                     string fs_Delimiter = ",")  //     fs_List
{
    int li_Len = StringLen (fs_List);
//----
    if (li_Len == 0) return (true);
    //----    ""
    if (fs_List == "-1") return (true);
    string ls_Magic = OrderMagicNumber();
    //----       
    int li_N = StringFind (fs_List, ls_Magic);
    //----       
    if (li_N < 0) return (false);
    //----       
    if (fs_List == ls_Magic) return (true);
    //----   
    int li_LenMagic = StringLen (ls_Magic);
    //----        (Delimiter)
    if (StringSubstr (fs_List, li_N + li_LenMagic, 1) == fs_Delimiter) return (true);
    //----      
    if (li_Len == li_N + li_LenMagic) return (true);
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

